
' Region Description
'
' Name: ADRepCheckLatency-Inject.vbs
' Author: Nils Kaczenski
' Version: see code
' Description: see Readme-Howto.txt
' inspired by a design by Florian Frommherz 
' 
' EndRegion

' Script name
strTitel = "ADRepCheckLatency-Inject 1.0"

' have we been called by cscript?
If InStr(1, WScript.FullName, "cscript", vbTextCompare) = 0 Then 
	' no - tell user to do so
	InputBox "Please run this script from a CMD window using the following command line." _
	& VbCrLf & "You need write permission to the Active Directory object the script modifies.", _
	strTitel, "cscript " & """" & WScript.ScriptFullName & """"
	WScript.Quit
End If

' read parameters from external script file
strParametersFileName = Replace(LCase(WScript.ScriptFullName), "inject", "parameters")
Include strParametersFileName

WScript.Echo strTitel & ": Started at " & Now & " (local time)"
WScript.Echo VbCrLf & "Retrieving data from AD ..." & VbCrLf

' bind to object
Set objChange = GetObject("LDAP://" & strLocalDC & "/" & strObject)

' retrieve original data
dtmWhenCreated = objChange.Get("whenCreated")
dtmWhenChanged = objChange.Get("whenChanged")
' attribute could be empty, so catch errors
strPreviousValue = ""
On Error Resume Next
strPreviousValue = objChange.Get(strAttribute)
On Error Goto 0
If strPreviousValue = "" Then strPreviousValue = "<none>"

WScript.Echo "Data before Change Injection"
WScript.Echo "----------------------------"
WScript.Echo "Local DC: " & strLocalDC
WScript.Echo "Object: " & strObject
WScript.Echo "Object created: " & dtmWhenCreated
WScript.Echo "Object changed locally: " & dtmWhenChanged
WScript.Echo "Attribute to change: " & strAttribute
WScript.Echo "Current value: " & strPreviousValue
WScript.Echo "New value to set: " & strNewValue

If strPreviousValue = strNewValue Then
	WScript.Echo VbCrLf & "Aborting script!"
	WScript.Echo "The new value is the same as the current value."
	WScript.Echo "This means AD will do no change that we could detect."
	WScript.Echo "Please modify the New value in the Parameters file: "
	WScript.Echo strParametersFileName
	WScript.Echo "and then rerun this script."
	WScript.Quit
End If

' Inject change
WScript.Echo VbCrLf & "Changing data: " & Now  & " (local time)" & VbCrLf

objChange.Put strAttribute, strNewValue
objChange.SetInfo

' retrieve new data
'objChange.GetInfoEx Array("whenCreated", "whenChanged", strAttribute),1
objChange.GetInfo
dtmWhenCreated = objChange.Get("whenCreated")
dtmWhenChanged = objChange.Get("whenChanged")
' attribute could be empty, so catch errors
strCurrentValue = ""
On Error Resume Next
strCurrentValue = objChange.Get(strAttribute)
On Error Goto 0
If strCurrentValue = "" Then strCurrentValue = "<none>"

WScript.Echo "Data after Change Injection"
WScript.Echo "---------------------------"
WScript.Echo "Local DC: " & strLocalDC
WScript.Echo "Object: " & strObject
WScript.Echo "Object created: " & dtmWhenCreated
WScript.Echo "Object changed locally: " & dtmWhenChanged
WScript.Echo "Attribute to change: " & strAttribute
WScript.Echo "Current value: " & strCurrentValue

WScript.Echo VbCrLf & strTitel & ": Finished at " & Now & " (local time)"

' VBScript "Include" routine
Sub Include(sInstFile)
	On Error Resume Next

	Dim oFSO, f, s

	Set oFSO = CreateObject("Scripting.FileSystemObject")
	If oFSO.FileExists(sInstFile) Then
		Set f = oFSO.OpenTextFile(sInstFile)
		s = f.ReadAll
		f.Close
		ExecuteGlobal s
	End If

	Set oFSO = Nothing
	Set f = Nothing
End Sub
